;
; Registros "alias"
; PC = R0  (forzado por el hardware)
; SP = R1  (arbitrario) 
; LR = R2  (arbitrario)
;
	org 0		; Reset
	jr start
	xor pc,pc,sp	; Pila al final de la RAM

	org 2
	reti		; Rutina de interrupcion
	nop
	
	; borramos pantalla con caracter fijo
start:	ld (pc),r7	; puntero
	word 4096
	ld (pc),r6	; contador
	word 1920
	ld (pc),r4	; caracter espacio
	word 32

buc:	st r4,(r7)
        addq r7,1,r7
	subq r6,1,r6
	jr.nz buc
	nop

uno:	xor sp,sp,r6	; Y
	xor sp,sp,r5	; X
	addq r5,1,r7	; inc X
	addq r5,1,r3	; inc Y
	addq r4,3,r4	; caracter #

buc1:	subq r4,3,r4	;Borramos caracter actual
	addq pc,2,lr
	jr putxy
	nop    
	add r5,r7,r5	;incrementamos X
	neg.z r7,r7	;si X=0 invertimos incremento X 
	ld (pc),r1
	word 79
	sub r5,r1,r1
	neg.z r7,r7	;si X=79 invertimos incremento X

	add r6,r3,r6	;incrementamos Y 
	neg.z r3,r3	;si Y=0 invertimos incremento Y
	ld (pc),r1
        word 23   
        sub r6,r1,r1
        neg.z r3,r3 	;si Y=23 invertimos incremento Y

	addq r4,3,r4	;imprimimos #
	addq pc,2,lr
        jr putxy
	nop
	addq pc,2,lr
        jr retardo
        nop

	jr buc1
	nop
	
; rutina putxy
; R6: y
; R5: x
; R4: caracter a imprimir
; R2: direccin de retorno

putxy:	subq sp,1,sp
	st r3,(sp)
	subq sp,1,sp
	st r7,(sp)

	add r6,r6,r7 ; y*2
	add r7,r7,r7 ; y*4
	add r6,r7,r7 ; y*5
	add r7,r7,r7 ; y*10
	add r7,r7,r7 ; y*20
	add r7,r7,r7 ; y*40
	add r7,r7,r7 ; y*80
	add r5,r7,r7 ; y*80+x
	ld (pc),r3
	word 4096
	add r3,r7,r7 ; dir video
	st r4,(r7)

	ld (sp),r7
	addq sp,1,sp
	ld (sp),r3
	addq sp,1,sp
	or lr,lr,pc  ; retorno
	nop 

retardo:
	subq sp,1,sp
        st r3,(sp)
	xor r3,r3,r3
ret1:	subq r3,1,r3
	jr.nz ret1
	nop
        ld (sp),r3
	addq sp,1,sp
        or lr,lr,pc  ; retorno
        nop

